<?php

defined( 'ABSPATH' ) || exit;


class WC_Jetlinez_Order_Notifyz_Gateways
{
	private static $_instance;
	public $mobile = [];
	public $message = '';
	private $appKey = '';
	private $authKey = '';

	public function __construct() {
		$this->appKey  = WC_Jetlinez_Order_Notifyz()->Options( 'notify_gateway_app_key' );
		$this->authKey = WC_Jetlinez_Order_Notifyz()->Options( 'notify_gateway_auth_key' );
	}

	public static function init() {
		if ( ! self::$_instance ) {
			self::$_instance = new self();
		}

		return self::$_instance;
	}

	public static function get_notify_gateway() {

		$gateway = [
			'jetlinez' => 'jetlinez',
		];

		return apply_filters( 'wc_jetlinez_order_notifyz_gateways', $gateway );
	}

    public function jetlinez()
    {
        $appKey  = $this->appKey;
        $authKey = $this->authKey;
        $message = $this->message;
        $mobile = $this->mobile;
        $to;

        foreach ($mobile as $m) {
            $to = preg_replace('/^(?:\+?98|0)?/','+98', $m);
        }

        $curl = curl_init();

        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://my.jetlinez.com/api/create-message',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => array(
                'appkey' => $appKey,
                'authkey' => $authKey,
                'to' => $to,
                'message' => $message
            ),
        ));

        $response = curl_exec($curl);

        $response = json_decode($response);
        $status_code = $response->data->status_code;

        if ( $status_code == 200 ) {
            return true;
        }

        curl_close($curl);

        return false;
    }
}