<?php

defined( 'ABSPATH' ) || exit;


class WC_Jetlinez_Order_Notifyz_Init
{

    private static function services()
    {
        return [
            WC_Jetlinez_Order_Notifyz_Archive::class,
            WC_Jetlinez_Order_Notifyz_Bulk::class,
            WC_Jetlinez_Order_Notifyz_Contacts::class,
            WC_Jetlinez_Order_Notifyz_MetaBox::class,
            WC_Jetlinez_Order_Notifyz_Orders::class,
            WC_Jetlinez_Order_Notifyz_Product_Events::class,
            WC_Jetlinez_Order_Notifyz_Product_Tab::class,
            WC_Jetlinez_Order_Notifyz_Settings::class,
            WC_Jetlinez_Order_Notifyz_Settings_Api::class,
        ];
    }


    public static function register()
    {
        foreach ( self::services() as $service )
        {
            $service = self::instantiate( $service );

            if ( method_exists( $service, 'register' ) )
            {
                $service->register();
            }
        }
    }


    private static function instantiate( $class )
    {
        $service = new $class();

        return $service;
    }

}